#!/usr/bin/perl
use strict;
use warnings;
#use integer;
my $version=1;
my $expected_ImageMagick_version = "6.3.5";
my $acceptable_IM_version = "6.1.8";
#
#----------------------------------------
#Variables
#----------------------------------------
#dimensions refers to the dimension of a single cell
#The offsets give the location of the cell.
my %Xoffset_hash; my %Yoffset_hash;
my @spreadsheet_array;
my @identify_array; 
my $y=0;
my $which_white=72;
my $column; my $row;
my @awake_in_cell;

#Do not move or alter the following line. The program transfer parameters depends on it.
#INSERT_COORDINATES_HERE
#exp
$Xoffset_hash{0}=389;$Yoffset_hash{0}=236;
$Xoffset_hash{1}=279;$Yoffset_hash{1}=276;
$Xoffset_hash{2}=435;$Yoffset_hash{2}=346;
$Xoffset_hash{3}=191;$Yoffset_hash{3}=367;
$Xoffset_hash{4}=271;$Yoffset_hash{4}=364;
$Xoffset_hash{5}=326;$Yoffset_hash{5}=411;
$Xoffset_hash{6}=212;$Yoffset_hash{6}=438;
$Xoffset_hash{7}=453;$Yoffset_hash{7}=494;
$Xoffset_hash{8}=246;$Yoffset_hash{8}=528;
$Xoffset_hash{9}=315;$Yoffset_hash{9}=577;
$Xoffset_hash{10}=94;$Yoffset_hash{10}=650;

#cntrl
$Xoffset_hash{11}=174;$Yoffset_hash{11}=1024;
$Xoffset_hash{12}=195;$Yoffset_hash{12}=1081;
$Xoffset_hash{13}=340;$Yoffset_hash{13}=1121;
$Xoffset_hash{14}=335;$Yoffset_hash{14}=1171;
$Xoffset_hash{15}=439;$Yoffset_hash{15}=1189;
$Xoffset_hash{16}=320;$Yoffset_hash{16}=1201;
$Xoffset_hash{17}=442;$Yoffset_hash{17}=1243;
$Xoffset_hash{18}=266;$Yoffset_hash{18}=1235;
$Xoffset_hash{19}=176;$Yoffset_hash{19}=1264;
$Xoffset_hash{20}=393;$Yoffset_hash{20}=1302;
$Xoffset_hash{21}=252;$Yoffset_hash{21}=1328;
$Xoffset_hash{22}=305;$Yoffset_hash{22}=1380;
$Xoffset_hash{23}=386;$Yoffset_hash{23}=1370;
$Xoffset_hash{24}=470;$Yoffset_hash{24}=1460;
$Xoffset_hash{25}=322;$Yoffset_hash{25}=1493;

#how many cells are in photograph?
my $number_of_cells_per_image=10;
##dimensions of each cell
my $dimensions="15x15";
#END_COORDINATES

#batch number is here so that we can process them into subgroups.
my $number_of_batches;
#To what degree should we brighten the final image?
my $brightness_up=300;
#The first cell is cell zero, the next one is cell one. 
#$cell_number is the currnt cell that we are working with.
my $cell_number;
#Do you want debugging reports turned on? If this is a mystery to you then you don't want it on.
my $DEBUG=0;
my $x;

my $input_image1; my $input_image2; my $output_image;
my $cell_name;
my $formatted_number;

#@ARGV is an array that contains all of the command-line arguments.
#If it is empty, the test will fail, a suggestion will print and the program will exit.
#Use !=0 if you want just one argument. Use <1 is you want no fewer than 2 arguments.
#Use < 0 if you want 1 or more arguments.  Zero arguments gives a $#ARGV = -1.
# <3 means at least 4 arguments.
#This is how we handle wildcards. We let Bash handle the expansion of filenames.
#We just read them from $ARGV[];
if($#ARGV < 0)
{
	print "\n\n\n\n";
	print "|-----------------------------August 22, 2007---------------------------------|\n";
	print " Program name: $0\n";
	print " version #$version\n";
	print "\n";
	print " My purpose is to watch individual flies and to record when they \"wake up\".\n";
	print " The first image in series must be without animals. It is the blank.\n";
	print " You will set the coordinates to be a tight fitting boxes around each animal.\n";
	print " As long as the animal remains in place it will generate a white signal.\n";
	print " When the animal moves the white signal will drop to zero.\n";
	print " The data for each timepoint will be stored in \"results.txt\".\n";
	print " The time at which each animal moved will be stored in \"whenawake_nn.txt\"\n";
	print " in which \"nn\" specifies the time interval\n";
	print " Each cell is processed until the animal wakes up and then I stop.\n"; 
	print "\n";
	print " Example:\n";
	print " $0 *.JPG 30\n";
	print " The *.JPG will insure that all images which end in *.JPG will be processed.\n";
	print " They must all be in the same directory as the program.\n";
	print " The \"30\" indicates that the time between each photo is 30 time units.\n";
	print " The time is unit-less and so it might be seconds, minutes or hours.\n";
	print " If you don't want to specify a time interval then just insert a 1 and the\n";
	print " time variable will specifiy the image number.\n";
	print " \n";
	print " My advice to you is that you should not keep anything else in this directory.\n";
	print " I will overwrite files if they get in my way!\n";
	print "\n";
	print " I don't care how you use me, just please, please, USE ME!\n";
	print "|----------------------------by Nigel Atkinson--------------------------------|\n";
	exit; 
}
else
{
	print "version #$version\n";
}

my $version_checker=`identify -version`;
my $versionofimagemagick;
#Data looks like this:
#Version: ImageMagick 6.3.5 07/28/07 Q16 http://www.imagemagick.org
if($version_checker=~/Version: ImageMagick (\S+)/)
	{
		$versionofimagemagick = $1;
		if($expected_ImageMagick_version ne $versionofimagemagick && $acceptable_IM_version ne $versionofimagemagick) 
		{
			print "This script expects version $expected_ImageMagick_version.\n";
			print "You are using version $versionofimagemagick\n";
			print "Contact Nigel Atkinson to get an updated script.\n";
			exit;
		}
	}
else
	{
		print "I cannot determine the ImageMagick version.\n";
		print "I expect that the command \"identify -version\" will return the version number\n";
		print "Contact Nigel Atkinson to get an updated script.\n";
		exit;
	}	

#----------------------------------------------------
#open the outputfile which will store the spreadsheet
#This will be a tab delimited text file.
my $output_file;
$output_file="results.txt";
unless(open(OUTPUTFILE,">$output_file"))
{
	print("\ncannot open $output_file\n");
	exit;
}
#----------------------------------------------------

my $number_of_timepoints = @ARGV;
my @Files_to_process;

#$number_of_timepoints is the same for each cell.
#However, in the staggered version of the program (this one) each cell is added in consecutive images.
#So cell0 is added in the first picture, cell1 in picture 2, cell2 in picture 3, etc.
#So if we have 3 cells and we have taken 100 timeponts then we can only process 97 of those timepoints.
#In each case the first timepoint FOR EACH CELL is being subtracted from all of the rest. This should produce
#96 datapoints.
#For the first round of substractions for each cell this would be:
#image1cell0 - image0cell0, etc. AND image2cell1 - image1cell1, etc. AND image3cell2 - image2cell2, etc.)
#$number_of_timepoints gives the number of cells to manipulate but it does not tell us where to start our manipulations.
#my $number_of_timepoints = ($number_of_timepoints-$number_of_cells_per_image);

#Decrement this because the last value is the time interval.
#The time interval (last argument) is @ARGV-1 because we reference them from 0. The means that the for loops will work
#when reading arguments if you start counting from 0. 
$number_of_timepoints--;
my $timeinterval=$ARGV[$number_of_timepoints];
print "timeinterval=$timeinterval\n";

print "number of image files found=$number_of_timepoints\n";
print "number_of_cells_per_image=$number_of_cells_per_image\n";
print "actual number_of_timepoints to be produced=$number_of_timepoints\n";

for($x=0;$x<$number_of_timepoints;$x++)
{
	$Files_to_process[$x]=$ARGV[$x];
	print "$Files_to_process[$x]\n";
	
	#convert to 256 colors
	#print "convert $Files_to_process[$x] -depth 8 $Files_to_process[$x]\n";
	print `convert $Files_to_process[$x] -depth 8 $Files_to_process[$x]`;
}

for($cell_number=0; $cell_number<$number_of_cells_per_image; $cell_number++)
{
	print "cell$cell_number, number_of_cells_per_image=$number_of_cells_per_image, (Xoffset,Yoffset)=($Xoffset_hash{$cell_number},$Yoffset_hash{$cell_number}) number_of_timepoints=$number_of_timepoints\n";
	
	#Insert the column names into the spreadsheet array
	$spreadsheet_array[$cell_number][0]= "cell$cell_number";

	#my $final_cell=$number_of_timepoints-$cell_number;
	#mark
	$input_image1=$Files_to_process[(0)];
	$output_image="crop$cell_number.0.jpg";
	print `convert -crop $dimensions+$Xoffset_hash{$cell_number}+$Yoffset_hash{$cell_number} $input_image1 $output_image`;
	
		for($x=1; $x<($number_of_timepoints); $x++)
		{
			#This loop crops and simultaneously converts to jpg.
			#The blank for cell_number 0 is in $Files_to_process[0].
			#The blank for cell_number 1 is in $Files_to_process[1].
			#$input_image1=$Files_to_process[($x+$cell_number)];
			$input_image1=$Files_to_process[($x)];
			
			#The next line is the reason that the loop must count from 0 to the $final cell number.
			#This makes all of the consecuitively added tubes equivalent.
			#They must be consequitively numbered from zero for the next loop to work properly.
			$output_image="crop$cell_number.$x.jpg";
			#print "convert -crop $dimensions+$Xoffset_hash{$cell_number}+$Yoffset_hash{$cell_number} $input_image1 $output_image\n";
			print `convert -crop $dimensions+$Xoffset_hash{$cell_number}+$Yoffset_hash{$cell_number} $input_image1 $output_image`;
	
			$input_image1="crop$cell_number.0.jpg";
			$input_image2="crop$cell_number.$x.jpg";
			#$output_image="diff$cell_number.$x.jpg";
	
			#output_image has been replaced with cell name.
			# Format batch number with 3 digits
			$formatted_number = sprintf("%05d", $x);
			$cell_name="cell_$cell_number.$formatted_number.jpg";
			
			print `composite -compose difference $input_image1 $input_image2 $cell_name`;
	
			#grayscale
			print `convert $cell_name -colorspace gray $cell_name`;
			
			#turn up brightness/contrast
			print `mogrify -modulate $brightness_up $cell_name`;
	
			#Harvest the information from the file. This contains the white values.
			@identify_array= `identify -verbose $cell_name`; 
			
			print "$cell_name image manipulated\n";
			
			my $white=0;
			for($y=0; $y<@identify_array; $y++)
			{
		  		#  Histogram:
	    			#    247541: (  0,  0,  0)	black
	      			#      2459: (240,240,240)	grey94
	 	        	#	5: ( 87, 87, 87)	grey34
				#This will harvest the black number.
				#if($array[$y]=~/\w+(\d+):\s\(\s*\d+,\s*\d+,\s*\d+\)\s*black$/)
				#{
					#$black=$1;
				#}
				#Let's use grey29 as a default. I think that grey 29 is ( 72, 72, 72).
				#In the statement below we really don't need to capture $2, $3 & $4. However, we might be able to use it
				#as a way to confirm that all of the values are the same. If this is grey scale then all should be
				#the same value.
				if($identify_array[$y]=~/\s*(\d+): \(\s*(\d+),\s*(\d+),/)
				{ 
					#Now collect all of the greys that we want to call white.
					#First guess was 72
					#$which_white contains the white value to be used. You can define it at the beginning of the program.
					if($2>=$which_white)
					{
						$white=$white+$1;
						#print "\n$1: ( $2,$3,$4)\n";
					}
				}
	
				if($expected_ImageMagick_version eq $versionofimagemagick)
				{
		               		if($identify_array[$y+1]=~/\s*Colormap/)
					{
						#last;
						$y=@identify_array;
					}
				}
			}
			#$cell_number is how we want each column in the spreadsheet to begin.
			#It would be nice to store this in an 2 dim array.
			#spreadsheet_array[column][row] where the columns are different cells and the row are differnt times.
			$spreadsheet_array[$cell_number][$x]= "$white";
			if($white==0)
			{
				$awake_in_cell[$cell_number]=$x;
				$x=$number_of_timepoints+1;
			}
				
		}#end of batch loop
	#remove old files
	print `rm crop*`;
#}

}#end of cell for loop

my @time_column_labels;
$time_column_labels[0]="time";
for $row(1 .. ($number_of_timepoints))
{
	$time_column_labels[$row]=$row*$timeinterval;
}


print "Saving the spreadsheet\n";
for $row(0 .. ($number_of_timepoints))
{
	print OUTPUTFILE "$time_column_labels[$row]\t";
	for $column(0 .. $#spreadsheet_array)
	{
		#for $row(1 .. $#{$spreadsheet_array[$column]})
		print OUTPUTFILE $spreadsheet_array[$column][$row]."\t";
	}
	print OUTPUTFILE "\n";
}
close OUTPUTFILE;

#----------------------------------------------------
#open the outputfile which will store the spreadsheet
#This will be a tab delimited text file.
$output_file="whenawake_$timeinterval.txt\n";
unless(open(OUTPUTFILE,">$output_file"))
{
	print("\ncannot open $output_file\n");
	exit;
}
#----------------------------------------------------

my $line1="";
my $line2="";
for($cell_number=0; $cell_number<$number_of_cells_per_image; $cell_number++)
{
	$line1=$line1."cell_$cell_number\t";
	my $temp=$awake_in_cell[$cell_number]*$timeinterval;
	$line2=$line2."$temp\t";
	print "cell_number $cell_number awake in cell $awake_in_cell[$cell_number]\n";
}
$line1=$line1."\n";
$line2=$line2."\n";
print "$line1$line2\n";
print OUTPUTFILE "$line1$line2\n";

print "Termino\n";
exit;

#Notes
#The command for changing 16-bit (65536 colors) to 8-bit (256 colors) is:
#mogrify -depth 8 *.png
#	or 
#convert input_file.png -depth 8 output_file.png 
#The "-depth" command can have one of two arguments, 8 or 16.  8 bit 
#corresponds to 2^8 colors, and 16 is 2^16 colors. 

#convert everyone to 256 colors
#print "mogrify -depth 8 *.jpg\n";
#print `mogrify -depth 8 *.jpg`;

#convert 1.3.0.png -fill white -opaque black out.png
#convert 1.3.0.png -fill white -fuzz 5% -opaque black out.png
#convert 1.3.0.png -fill yellow4 -fuzz 50% -opaque white out.png
